module Slipsquare
  module Middleware
    class DownloadFile < Base
      def call(env)
        say "Download file..."

        begin
          contents = env['dropbox-client'].download env['download_file_name']
        rescue Dropbox::API::Error::NotFound => e
          say "File Not Found! Could not download", :red
          exit 1
        rescue Dropbox::API::Error => e
          say "Connection to Dropbox failed (#{e})", :red
          exit 1
        end

        File.open(env['download_file_name'], 'w') {|f| f.write(contents) }

        say "File '#{env['download_file_name']}' downloaded successfully!"

        @app.call(env)
      end
    end
  end
end