require 'table_print'

module Slipsquare
  module Middleware
    class MakeDirectory < Base
      def call(env)
        say "Creating directory on Dropbox..."

        friendly_path = env["mkdir_path"]

        if friendly_path =~ (/[\\\:\?\*\<\>\"\|]+/)
          friendly_path = friendly_path.gsub(/[\\\:\?\*\<\>\"\|]+/, '')
          say "Illegal character found! Escaping...", :yellow
          say "Escaped directory path: #{friendly_path}"
        end

        new_folder_response = env['dropbox-client'].mkdir(env["mkdir_path"])

        say "Directory `#{friendly_path}` created successfully", :green

        @app.call(env)
      end
    end
  end
end